package kieker.webgui.common;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.net.URLClassLoader;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;
import kieker.analysis.plugin.port.Plugin;

/**
 * @author Nils Christian Ehmke
 */
public class PluginFinder {

    public static List<Class<?>> getAllPluginsWithinJar(final URL url) throws IOException {
        final ClassLoader classLoader = new URLClassLoader(new URL[]{url});
        final JarFile jarFile = new JarFile(new File(url.getPath()));
        final List<Class<?>> result = new ArrayList<Class<?>>();
        Enumeration<JarEntry> jarEntries = jarFile.entries();
        while (jarEntries.hasMoreElements()) {
            JarEntry jarEntry = (JarEntry) jarEntries.nextElement();
            try {
                String name = jarEntry.toString();
                name = name.replace('/', '.');
                name = name.replace(".class", "");
                Class<?> c = classLoader.loadClass(name);
                if (c.isAnnotationPresent(Plugin.class)) {
                    result.add(c);
                }
            } catch (Throwable ex) {
            }
        }
        return result;
    }
}
